/*
 * Copyright © 2012 Canonical Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authored by:
 *  Alan Griffiths <alan@octopull.co.uk>
 *  Thomas Voss <thomas.voss@canonical.com>
 */

#ifndef MIR_COMPOSITOR_BUFFER_STREAM_FACTORY_H_
#define MIR_COMPOSITOR_BUFFER_STREAM_FACTORY_H_

#include "mir/compositor/buffer.h"
#include "mir/surfaces/buffer_stream_factory.h"

#include <memory>

namespace mir
{
namespace compositor
{

class BufferAllocationStrategy;
class GraphicBufferAllocator;
struct BufferProperties;

class BufferStreamFactory : public surfaces::BufferStreamFactory
{
public:

    explicit BufferStreamFactory(
        const std::shared_ptr<BufferAllocationStrategy>& strategy);

    virtual ~BufferStreamFactory() {}

    // From BufferStreamFactory
    virtual std::shared_ptr<surfaces::BufferStream> create_buffer_stream(
        BufferProperties const& buffer_properties);

private:
    std::shared_ptr<BufferAllocationStrategy> swapper_factory;

};

}
}


#endif /* MIR_COMPOSITOR_BUFFER_STREAM_FACTORY_H_ */
